//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// DownloadListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "DownloadListCtrl.h"
#include "otherfunctions.h" 
#include "updownclient.h"
#include "opcodes.h"
#include "ClientDetailDialog.h"
#include "FileDetailDialog.h"

// CDownloadListCtrl

// hmm some parts here might be overkill ;) ...
// oh well at least I can do/draw/paint everything I want in this window now ;)

IMPLEMENT_DYNAMIC(CDownloadListCtrl, CListBox)
CDownloadListCtrl::CDownloadListCtrl(){
	memset(&asc_sort,0,7);
}

CDownloadListCtrl::~CDownloadListCtrl(){

	for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos))
		delete listcontent.GetAt(pos);
}

void CDownloadListCtrl::Init(){
	CImageList m_ImageList; //dummy list
	m_ImageList.Create(1, 17,ILC_COLOR, 1, 1); 
	SetImageList(&m_ImageList, LVSIL_SMALL);
	SetStyle();

	ModifyStyle(LVS_SINGLESEL,0);

	InsertColumn(0,GetResString(IDS_DL_FILENAME),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(0));
	InsertColumn(1,GetResString(IDS_DL_SIZE),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(1));
	InsertColumn(2,GetResString(IDS_DL_TRANSF),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(2));
	InsertColumn(3,GetResString(IDS_DL_SPEED),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(3));
	InsertColumn(4,GetResString(IDS_DL_PROGRESS),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(4));
	InsertColumn(5,GetResString(IDS_DL_SOURCES),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(5));
	InsertColumn(6,GetResString(IDS_PRIORITY),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(6));
	InsertColumn(7,GetResString(IDS_STATUS),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(7)); 
	InsertColumn(8,GetResString(IDS_DL_REMAINS),LVCFMT_LEFT,theApp.glob_prefs->GetTransferColumnWidth(8)); 

	imagelist.Create(15,15,ILC_COLOR32,0,10);
	imagelist.SetBkColor(GetBkColor());
	imagelist.Add(theApp.LoadIcon(IDI_DCS1));
	imagelist.Add(theApp.LoadIcon(IDI_DCS2));
	imagelist.Add(theApp.LoadIcon(IDI_DCS3));
	imagelist.Add(theApp.LoadIcon(IDI_DCS4));
	imagelist.Add(theApp.LoadIcon(IDI_COMPPROT));
	m_PrioMenu.CreateMenu();
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));

	m_FileMenu.CreatePopupMenu();
	m_FileMenu.AddMenuTitle(GetResString(IDS_DOWNLOADMENUTITLE));
	m_FileMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PrioMenu.m_hMenu, GetResString(IDS_PRIORITY) );

	m_FileMenu.AppendMenu(MF_STRING,MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL) );
	m_FileMenu.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_DL_STOP));
	m_FileMenu.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_DL_PAUSE));
	m_FileMenu.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_DL_RESUME));
	m_FileMenu.AppendMenu(MF_SEPARATOR);
	m_FileMenu.AppendMenu(MF_STRING,MP_OPEN, GetResString(IDS_DL_OPEN) );//<--9/21/02
	m_FileMenu.AppendMenu(MF_STRING,MP_PREVIEW, GetResString(IDS_DL_PREVIEW) );
	m_FileMenu.AppendMenu(MF_STRING,MP_METINFO, GetResString(IDS_DL_INFO) );//<--9/21/02
	m_FileMenu.AppendMenu(MF_SEPARATOR);
	m_FileMenu.AppendMenu(MF_STRING,MP_CLEARCOMPLETED, GetResString(IDS_DL_CLEAR));
	m_FileMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1) );
	m_FileMenu.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2));
	SetMenu(&m_FileMenu);

	m_ClientMenu.CreatePopupMenu();
	m_ClientMenu.AddMenuTitle(GetResString(IDS_CLIENTS));
	m_ClientMenu.AppendMenu(MF_STRING,MP_DETAIL, GetResString(IDS_SHOWDETAILS));
	m_ClientMenu.AppendMenu(MF_STRING,MP_MESSAGE, GetResString(IDS_SEND_MSG));
}

void CDownloadListCtrl::AddFile(CPartFile* toadd){
	CtrlItem_Struct* newitem = new CtrlItem_Struct;
	uint16 itemnr = GetItemCount();
	newitem->owner = 0;
	newitem->type = 1;
	newitem->value = toadd;
	listcontent.AddTail(newitem);
	InsertItem(LVIF_PARAM,itemnr,0,0,0,0,(LPARAM)newitem);
}

void CDownloadListCtrl::AddSource(CPartFile* owner,CUpDownClient* source,bool notavailable){
	
	CtrlItem_Struct* newitem = new CtrlItem_Struct;
	newitem->owner = owner;
	newitem->type = (notavailable)? 3:2;
	newitem->value = source;
	listcontent.AddTail(newitem);
	if (!owner->srcarevisible)
		return;
	CtrlItem_Struct* search = 0;
	for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos)){
		if (listcontent.GetAt(pos)->value == owner){
			search = listcontent.GetAt(pos);
			break;
		}
	}
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)search;
	uint16 itemnr = FindItem(&find);
	while (GetItemCount() > itemnr+1 && ((CtrlItem_Struct*)GetItemData(itemnr+1))->type != 1)
		itemnr++;
	InsertItem(LVIF_PARAM,itemnr+1,0,0,0,0,(LPARAM)newitem);
}

void CDownloadListCtrl::RemoveSource(CUpDownClient* source,CPartFile* owner){
   POSITION pos1, pos2;
   for( pos1 = listcontent.GetHeadPosition(); ( pos2 = pos1 ) != NULL; ){
	   listcontent.GetNext(pos1);
	   CtrlItem_Struct* delitem = listcontent.GetAt(pos2);
	   if(delitem->value == source && (delitem->owner == owner || (!owner) ) ){
 			LVFINDINFO find;
			find.flags = LVFI_PARAM;
			find.lParam = (LPARAM)delitem;
			sint16 result = FindItem(&find);
			if (result != (-1))
				DeleteItem(result);
			listcontent.RemoveAt(pos2);
			delete delitem;
       }
   }
}

void CDownloadListCtrl::RemoveFile(CPartFile* toremove){
   POSITION pos1, pos2;
   for( pos1 = listcontent.GetHeadPosition(); ( pos2 = pos1 ) != NULL; ){
	   CtrlItem_Struct* delitem = listcontent.GetNext(pos1);    
	   if(delitem->value == toremove){
 			LVFINDINFO find;
			find.flags = LVFI_PARAM;
			find.lParam = (LPARAM)delitem;
			sint16 result = FindItem(&find);
			if (result != -1)
				DeleteItem(result);
			listcontent.RemoveAt(pos2);
			delete[] delitem;
			return;
       }
   }
}

void CDownloadListCtrl::UpdateItem(void* toupdate){
	CtrlItem_Struct* search = 0;
	for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos)){
		if (listcontent.GetAt(pos)->value == toupdate){
			search = listcontent.GetAt(pos);
			LVFINDINFO find;
			find.flags = LVFI_PARAM;
			find.lParam = (LPARAM)search;
			sint16 result = FindItem(&find);
			if (result != -1)
				Update(result);
			return;
		}
	}
}

void CDownloadListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct){
	if (!lpDrawItemStruct->itemData)
		return;
	CtrlItem_Struct* content = (CtrlItem_Struct*)lpDrawItemStruct->itemData;
	//CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	CMemDC dc(CDC::FromHandle(lpDrawItemStruct->hDC),&CRect(lpDrawItemStruct->rcItem));
	dc.SelectObject(GetFont());
	
	COLORREF crOldTextColor = dc->GetTextColor();
	COLORREF crOldBkColor = dc->GetBkColor();
	RECT sel_rec;
	memcpy(&sel_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));
	sel_rec.bottom--;
	sel_rec.top++;
	RECT cur_rec;
	memcpy(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

	if (content->type == 1){
		CPartFile* partfile = (CPartFile*)content->value;

		if ((lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED))
			dc->SetTextColor(RGB(255,0,0));
		char buffer[200];char buffer2[20];
		// file name
		cur_rec.right = cur_rec.left + GetColumnWidth(0);
		cur_rec.left += 4;
		dc->DrawText(partfile->GetFileName(),(int)strlen(partfile->GetFileName()),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
		//size
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(1);
		CastItoXBytes(partfile->GetFileSize(),buffer);
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
		// transfered
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(2);
		CastItoXBytes(partfile->GetTransfered(),buffer);
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );	
		// speed
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(3);
		if (partfile->GetTransferingSrcCount()==0)
			sprintf(buffer, "-");
		else
			sprintf(buffer,"%.1f KB/s",(float)partfile->GetDatarate()/1024);
		
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );

		// Progress
		cur_rec.left = cur_rec.right;
		cur_rec.right += GetColumnWidth(4);
		cur_rec.bottom--;
		cur_rec.top++;
		partfile->DrawStatusBar(dc,&cur_rec);
		cur_rec.bottom++;
		cur_rec.top--;
		//sources
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(5);
		if(partfile->GetNoNeededPartSourcesCount()>0) sprintf(buffer2,"/%i",partfile->GetNoNeededPartSourcesCount()); else sprintf(buffer2,"");
		sprintf(buffer,"%i%s (%i)",partfile->GetSourceCount(),buffer2,partfile->GetTransferingSrcCount());
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
		//prio
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(6);
		switch(partfile->GetPriority()){
		case 0:
			dc->DrawText(GetResString(IDS_PRIOLOW) ,GetResString(IDS_PRIOLOW).GetLength(),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
			break;
		case 1:
			dc->DrawText(GetResString(IDS_PRIONORMAL),GetResString(IDS_PRIONORMAL).GetLength(),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
			break;
		case 2:
			dc->DrawText(GetResString(IDS_PRIOHIGH),GetResString(IDS_PRIOHIGH).GetLength(),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
			break;
		default:
			break;
		}
		//<<--9/21/02
		cur_rec.left = cur_rec.right+4; 
		cur_rec.right += GetColumnWidth(7); 
		sprintf(buffer,"%s", partfile->getPartfileStatus()); 
		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX ); 
		// Remaining Time & Size 
		cur_rec.left = cur_rec.right+4; 
		cur_rec.right += GetColumnWidth(8); 
		char bufferSize[50]; 
		char bufferTime[50]; 

		//size 
		uint32 remains; 
		remains=partfile->GetFileSize()-partfile->GetCompletedSize();		//<<-- 09/27/2002, CML

		if( remains < 0 ) remains = 0;
		CastItoXBytes(remains,bufferSize); 

		// time 
		uint32 restTime=partfile->getTimeRemaining();
		if (restTime==-1) sprintf(bufferTime,"?"); else CastSecondsToHM(restTime,bufferTime); 
		sprintf(buffer,"%s (%s)",bufferTime,bufferSize); 
		if (partfile->GetStatus()==PS_COMPLETING || partfile->GetStatus()==PS_COMPLETE ) 
			sprintf(buffer,""); 

		dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX ); 
	}
	else if (content->type == 3 || content->type == 2){
		CUpDownClient* client = (CUpDownClient*)content->value;
		//icon, name, status
		cur_rec.left += 17;
		cur_rec.right = cur_rec.left + GetColumnWidth(0) + GetColumnWidth(1);
		CString status;
		POINT point= {cur_rec.left,cur_rec.top+1};
		if (content->type == 2){
			switch (client->GetDownloadState()){
				case DS_CONNECTING:
					imagelist.Draw(dc,2, point,ILD_NORMAL);
					status = GetResString(IDS_CONNECTING);
					break;
				case DS_CONNECTED:
					imagelist.Draw(dc,2, point,ILD_NORMAL);
					status = GetResString(IDS_ASKING);
					break;
				case DS_WAITCALLBACK:
					imagelist.Draw(dc,2, point,ILD_NORMAL);
					status = GetResString(IDS_CONNVIASERVER);
					break;
				case DS_ONQUEUE:
					imagelist.Draw(dc,1, point,ILD_NORMAL);
					status = GetResString(IDS_ONQUEUE);
					break;
				case DS_DOWNLOADING:
					imagelist.Draw(dc,0, point,ILD_NORMAL);
					status = GetResString(IDS_TRANSFERRING);
					break;
				case DS_REQHASHSET:
					imagelist.Draw(dc,0, point,ILD_NORMAL);
					status = GetResString(IDS_RECHASHSET);
					break;
				case DS_NONEEDEDPARTS:
					imagelist.Draw(dc,3, point,ILD_NORMAL);
					status = GetResString(IDS_NONEEDEDPARTS);
					break;
				case DS_LOWTOLOWIP:
					imagelist.Draw(dc,3, point,ILD_NORMAL);
					status = GetResString(IDS_NOCONNECTLOW2LOW);
					break;
				default:
					status = GetResString(IDS_UNKNOWN);
			}
		}
		else{
			
			imagelist.Draw(dc,3, point,ILD_NORMAL);
			status = GetResString(IDS_ASKED4ANOTHERFILE);
		}
		cur_rec.left += 20;

		if (client->ExtProtocolAvailable()){
			POINT point2= {cur_rec.left,cur_rec.top+1};
			imagelist.Draw(dc,4, point2,ILD_NORMAL);
			cur_rec.left += 20;
		}

		char* buffer1;
		if (!client->GetUserName()){
			buffer1 = new char[50];
			sprintf(buffer1,"?  (%s)",status);
		}
		else{
			buffer1 = new char[strlen(client->GetUserName())+50];
			sprintf(buffer1,"%s  (%s)",client->GetUserName(),status);
		}
		dc->DrawText(buffer1,(int)strlen(buffer1),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
		delete[] buffer1;

		char buffer[100];		
		// transfered
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(2);
		if (content->type == 2){
			CastItoXBytes(client->GetTransferedDown(),buffer);
			dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );	
		}
		// speed
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(3);
		if (content->type == 2){
			sprintf(buffer,"%.1f KB/s",(float)client->GetDownloadDatarate()/1024);
			dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
		}
		// file info
		cur_rec.left = cur_rec.right;
		cur_rec.right += GetColumnWidth(4);
		client->DrawStatusBar(dc,&cur_rec,(content->type == 3));

		//sources
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(5);
		//prio
		cur_rec.left = cur_rec.right+4;
		cur_rec.right += GetColumnWidth(6);
		if (client->GetRemoteQueueRank()){
			sprintf(buffer,"QR: %u",client->GetRemoteQueueRank());
			dc->DrawText(buffer,(int)strlen(buffer),&cur_rec, DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX );
		}
	}
	dc->SetTextColor(crOldTextColor);
	dc->SetBkColor(crOldBkColor);

}


BEGIN_MESSAGE_MAP(CDownloadListCtrl, CListCtrl)
	ON_NOTIFY_REFLECT(LVN_ITEMACTIVATE, OnLvnItemActivate)
	ON_WM_ERASEBKGND()
	ON_NOTIFY_REFLECT (NM_RCLICK, OnNMRclick)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
END_MESSAGE_MAP()



// CDownloadListCtrl message handlers

void CDownloadListCtrl::OnLvnItemActivate(NMHDR *pNMHDR, LRESULT *pResult){
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(pNMIA->iItem);

	if (content->type == 1){
		SetRedraw(false);

		CPartFile* partfile = (CPartFile*)content->value;
		
		if ( (!partfile->srcarevisible) && partfile->GetSourceCount()>0 ){
			for (POSITION pos = listcontent.GetHeadPosition();pos != 0;listcontent.GetNext(pos)){
				if (listcontent.GetAt(pos)->owner == partfile)
					InsertItem(LVIF_PARAM,pNMIA->iItem+1,0,0,0,0,(LPARAM)listcontent.GetAt(pos));
			}
			partfile->srcarevisible = true;
		}
		else{
			while (GetItemCount() > pNMIA->iItem+1 && ((CtrlItem_Struct*)GetItemData(pNMIA->iItem+1))->type != 1)
				DeleteItem(pNMIA->iItem+1);
			partfile->srcarevisible = false;
		}
		SetRedraw(true);
	}
	*pResult = 0;
}

BOOL CDownloadListCtrl::OnEraseBkgnd(CDC* pDC) {
  // flickerfree-draw only on places background where we need background and not one pixel more ;)
  // --
  // thanks to denominator for a fix
  uint16 count = GetItemCount()-GetTopIndex(); 
  if (!count) 
    return CListCtrl::OnEraseBkgnd(pDC); 

  RECT clientrect; 
  RECT itemheigth; 
  RECT headerrect; 
  GetHeaderCtrl()->GetClientRect(&headerrect); 
  GetItemRect(GetTopIndex(),&itemheigth,LVIR_BOUNDS); 

  GetClientRect(&clientrect); 
  clientrect.top = headerrect.bottom; 
  clientrect.bottom = itemheigth.top; 
  pDC->FillSolidRect(&clientrect,GetBkColor()); 

  GetClientRect(&clientrect); 
  if (count*(itemheigth.bottom - itemheigth.top) < clientrect.bottom - itemheigth.top){ 
    clientrect.top = count*(itemheigth.bottom - itemheigth.top) + itemheigth.top; 
    pDC->FillSolidRect(&clientrect,GetBkColor());  
  } 

  GetClientRect(&clientrect); 
  if (itemheigth.right < clientrect.right){ 
    clientrect.left = itemheigth.right; 
    pDC->FillSolidRect(&clientrect,GetBkColor()); 
  } 
  return true; 
}

void CDownloadListCtrl::OnNMRclick(NMHDR *pNMHDR, LRESULT *pResult){	
	POINT point;
	::GetCursorPos(&point);
	if (GetSelectionMark() != (-1)){
		CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(GetSelectionMark());
		if (content->type == 1){
			CPartFile* file = (CPartFile*)content->value;
			m_FileMenu.EnableMenuItem(MP_PAUSE,((file->GetStatus() != PS_PAUSED) ? MF_ENABLED:MF_GRAYED));
			m_FileMenu.EnableMenuItem(MP_STOP,((file->GetStatus() != PS_PAUSED) ? MF_ENABLED:MF_GRAYED));
			m_FileMenu.EnableMenuItem(MP_RESUME,((file->GetStatus() == PS_PAUSED) ? MF_ENABLED:MF_GRAYED));
	        m_FileMenu.EnableMenuItem(MP_OPEN,((file->GetStatus() == PS_COMPLETE) ? MF_ENABLED:MF_GRAYED)); //<<--9/21/02
			m_FileMenu.EnableMenuItem(MP_PREVIEW,((file->PreviewAvailable()) ? MF_ENABLED:MF_GRAYED));

			m_FileMenu.EnableMenuItem(MP_CANCEL,MF_ENABLED);

			m_PrioMenu.CheckMenuItem(MP_PRIOHIGH,(file->GetPriority() == PR_HIGH)? MF_CHECKED:MF_UNCHECKED);
			m_PrioMenu.CheckMenuItem(MP_PRIONORMAL,(file->GetPriority() == PR_NORMAL)? MF_CHECKED:MF_UNCHECKED);
			m_PrioMenu.CheckMenuItem(MP_PRIOLOW,(file->GetPriority() == PR_LOW)? MF_CHECKED:MF_UNCHECKED);

			m_FileMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
		}else
			m_ClientMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	}
	else{
		m_FileMenu.EnableMenuItem(MP_CANCEL,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_PAUSE,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_STOP,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_RESUME,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_PREVIEW,MF_GRAYED);
		m_FileMenu.EnableMenuItem(MP_OPEN,MF_GRAYED); //<<--9/21/02
		m_FileMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	}
	*pResult = 0;
}

BOOL CDownloadListCtrl::OnCommand(WPARAM wParam,LPARAM lParam ){
	if (GetSelectionMark() != (-1)){
		CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(GetSelectionMark());
		
		///////////////////////////////////////////////////////////// 
		//for multiple selections 
		UINT selectedCount = this->GetSelectedCount(); 
		CTypedPtrList<CPtrList, CPartFile*> selectedList; 
		int index = -1; 
		POSITION pos = this->GetFirstSelectedItemPosition(); 
		while(pos != NULL) 
		{ 
			index = this->GetNextSelectedItem(pos); 
			if(index > -1) 
			{
				if (((CtrlItem_Struct*)this->GetItemData(index))->type == 1) 
					selectedList.AddTail((CPartFile*)((CtrlItem_Struct*)this->GetItemData(index))->value); 
			} 
		} 

		if (content->type == 1){
			CPartFile* file = (CPartFile*)content->value;

			switch (wParam)
			{
				case MP_CANCEL:
				{
					//for multiple selections 
					if(selectedCount > 1)
					{ 
						CString fileList; 
						for (pos = selectedList.GetHeadPosition() ; pos != 0 ; selectedList.GetNext(pos))
						{
							fileList += "\n" ; 
							fileList += selectedList.GetAt(pos)->GetFileName(); 
						} 
						if (MessageBox(("Are you sure that you want to cancel and delete these files?\n" + fileList),"Cancel",MB_ICONQUESTION|MB_YESNO) == IDYES)
						{ 
							while(!selectedList.IsEmpty())
							{
								switch(selectedList.GetHead()->GetStatus()) { 
									case PS_WAITINGFORHASH: 
									case PS_HASHING: 
									case PS_COMPLETING: 
									case PS_COMPLETE: 
										selectedList.RemoveHead(); 
										break; 
									default: 
									selectedList.GetHead()->DeleteFile(); 
									selectedList.RemoveHead(); 
								}
							}  
						}
						break; 
					}
					// single selection
					switch(file->GetStatus())
					{
						case PS_WAITINGFORHASH:
						case PS_HASHING:
						case PS_COMPLETING:
						case PS_COMPLETE:
							break;
						default:
						if (MessageBox(GetResString(IDS_Q_CANCELDL),GetResString(IDS_CANCEL),MB_ICONQUESTION|MB_YESNO) == IDYES)
			                file->DeleteFile();
						break;
					}
					break;
				}
				case MP_PRIOHIGH:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->SetPriority(PR_HIGH); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->SetPriority(PR_HIGH);
					break;
				case MP_PRIOLOW:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->SetPriority(PR_LOW); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->SetPriority(PR_LOW);
					break;
				case MP_PRIONORMAL:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->SetPriority(PR_NORMAL); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->SetPriority(PR_NORMAL);
					break;
				case MP_PAUSE:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->PauseFile(); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->PauseFile();
					break;
				case MP_RESUME:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->ResumeFile(); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->ResumeFile();
					break;
				case MP_STOP:
					if(selectedCount > 1)
					{
						while(!selectedList.IsEmpty()) { 
							selectedList.GetHead()->StopFile(); 
							selectedList.RemoveHead(); 
						} 
						break; 
					} 
					file->StopFile();
					break;
				case MP_CLEARCOMPLETED:
					ClearCompleted();
					break;
				case MP_METINFO:
					{
						CFileDetailDialog dialog(file);
						dialog.DoModal();
						break;
					}
				case MP_GETED2KLINK:
					if(selectedCount > 1)
					{
						CString str;
						while(!selectedList.IsEmpty()) { 
							str += theApp.CreateED2kLink(selectedList.GetHead()) + "\n"; 
							selectedList.RemoveHead(); 
						}
						theApp.CopyTextToClipboard(str);
						AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break; 
					} 
					theApp.CopyTextToClipboard(theApp.CreateED2kLink(file));
					break;
				case MP_GETHTMLED2KLINK:
					if(selectedCount > 1)
					{
						CString str;
						while(!selectedList.IsEmpty()) { 
							str += theApp.CreateHTMLED2kLink(selectedList.GetHead()) + "\n"; 
							selectedList.RemoveHead(); 
						}
						theApp.CopyTextToClipboard(str);
						AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break; 
					} 
					theApp.CopyTextToClipboard(theApp.CreateHTMLED2kLink(file));
					break;
				case MP_OPEN:{
					if(selectedCount > 1)
						break;
					char* buffer = new char[250];
					sprintf(buffer,"%s\\%s",theApp.glob_prefs->GetIncomingDir(),file->GetFileName());
					ShellOpenFile(buffer);
					delete buffer;
					break; 
				}
				case MP_PREVIEW:{
					if(selectedCount > 1)
						break;
					file->PreviewFile();
					break;
				}
			}
		}
		else{
			CUpDownClient* client = (CUpDownClient*)content->value;
			switch (wParam){
				case MP_MESSAGE:
					theApp.emuledlg->chatwnd.StartSession(client);
					break;
				case MP_DETAIL:
					CClientDetailDialog dialog(client);
					dialog.DoModal();
					break;
			}
		}
		// cleanup multiselection
		selectedList.RemoveAll(); 

	}
	else /*nothing selected*/
	{
		switch (wParam){
			case MP_CLEARCOMPLETED:
				ClearCompleted();
				break;
		}

	}

	return true;
}

void CDownloadListCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult){
	CollapseItems(1);
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// if it's a second click on the same column then reverse the sort order,
	// otherwise sort the new column in ascending order.
	asc_sort[pNMListView->iSubItem] = !asc_sort[pNMListView->iSubItem];
	SortItems(&SortProc,pNMListView->iSubItem+ ((asc_sort[pNMListView->iSubItem])? 0:10));
	*pResult = 0;
}

int CDownloadListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){
	CtrlItem_Struct* item1 = (CtrlItem_Struct*)lParam1;
	CtrlItem_Struct* item2 = (CtrlItem_Struct*)lParam2;
	if ((item1->type == 1 && item2->type != 1) || (item2->type == 1 && item1->type != 1))
		return 0;
	if (item1->type == 1){
		CPartFile* file1 = (CPartFile*)item1->value;
		CPartFile* file2 = (CPartFile*)item2->value;
		if (file1->srcarevisible || file2->srcarevisible)
			return 0;
		switch(lParamSort){
			case 0: //filename asc
				return strcmpi(file1->GetFileName(),file2->GetFileName());
			case 10: //filename desc
				return strcmpi(file2->GetFileName(),file1->GetFileName());
			case 1: //size asc
				return file2->GetFileSize() - file1->GetFileSize();
			case 11: //size desc
				return file1->GetFileSize() - file2->GetFileSize();
			case 2: //transfered asc
				return file2->GetTransfered() - file1->GetTransfered();

			case 12: //transfered desc
				return file1->GetTransfered() - file2->GetTransfered();
			case 3: //speed asc
				return file2->GetDatarate() - file1->GetDatarate();
			case 13: //speed desc
				return file1->GetDatarate() - file2->GetDatarate();
			case 4: //progress asc
				return file2->GetPercentCompleted() - file1->GetPercentCompleted();
			case 14: //progress desc
				return file1->GetPercentCompleted() - file2->GetPercentCompleted();
			case 5: //sources asc
				return file2->GetSourceCount() - file1->GetSourceCount();
			case 15: //sources desc
				return file1->GetSourceCount() - file2->GetSourceCount();
			case 6: //priority asc
				return file2->GetPriority() - file1->GetPriority();
			case 16: //priority desc
				return file1->GetPriority() - file2->GetPriority();

			case 7: //Status asc 
				return file1->getPartfileStatus().Compare(file2->getPartfileStatus()); 
			case 17: //Status desc 
				return file2->getPartfileStatus().Compare(file1->getPartfileStatus()); 
			case 8: //Remaining Time asc 
				return file2->getTimeRemaining()-file1->getTimeRemaining() ; 
			case 18: //Remaining Time desc 
				return file1->getTimeRemaining()-file2->getTimeRemaining() ;

			default:
				return 0;
		}
	}
	else{
		CUpDownClient* client1 = (CUpDownClient*)item1->value;
		CUpDownClient* client2 = (CUpDownClient*)item2->value;
		if (item1->type != item2->type)
			return item1->type - item2->type; 
		switch(lParamSort){
			case 0: //name asc
				if (!client1->GetUserName())
					return 1;
				else if(!client2->GetUserName())
					return -1;
				return strcmp(client1->GetUserName(),client2->GetUserName());
			case 10: //name desc
				if (!client1->GetUserName())
					return -1;
				else if(!client2->GetUserName())
					return 1;
				return strcmp(client2->GetUserName(),client1->GetUserName());
			case 1: //size but we use status asc
				return client2->GetDownloadState() - client1->GetDownloadState();
			case 11: //size but we use status desc
				return client1->GetDownloadState() - client2->GetDownloadState();
			case 2: //transfered asc
				return client2->GetTransferedDown() - client1->GetTransferedDown();
			case 12: //transfered desc
				return client1->GetTransferedDown() - client2->GetTransferedDown();
			case 3: //speed asc
				return client1->GetDownloadDatarate() - client2->GetDownloadDatarate();
			case 13: //speed desc
				return client2->GetDownloadDatarate() - client1->GetDownloadDatarate();
			case 4: //progress asc
				return client2->GetAvailablePartCount() - client1->GetAvailablePartCount();
			case 14: //progress desc
				return client1->GetAvailablePartCount() - client2->GetAvailablePartCount();
			default:
				return 0;
		}

	}
}

void CDownloadListCtrl::ClearCompleted(){
   POSITION pos1, pos2;
   for( pos1 = listcontent.GetHeadPosition(); ( pos2 = pos1 ) != NULL; ){
	   listcontent.GetNext(pos1);
	   CtrlItem_Struct* delitem = listcontent.GetAt(pos2);
	   if (delitem->type == 1){
		   CPartFile* file = (CPartFile*)delitem->value;
		   if (!file->IsPartFile())
			   RemoveFile(file);
	   }
   }
}

void CDownloadListCtrl::SetStyle() {
	
	if (theApp.glob_prefs->IsDoubleClickEnabled()) SetExtendedStyle(LVS_EX_FULLROWSELECT); else
		SetExtendedStyle(LVS_EX_ONECLICKACTIVATE | LVS_EX_FULLROWSELECT);

}

void CDownloadListCtrl::CollapseItems(int ignoreCount) {
  int myCount,index;
  myCount=0;
  index=-1;

  SetRedraw(false);
  while (index+1<GetItemCount()) {
	index++;

	CtrlItem_Struct* content = (CtrlItem_Struct*)this->GetItemData(index);
	CPartFile* partfile = (CPartFile*)content->value;
	if ( (content->type==1) && (partfile->srcarevisible) ) {
		myCount++;
		if (myCount>ignoreCount) {
			while (GetItemCount() > index+1 && ((CtrlItem_Struct*)GetItemData(index+1))->type != 1)
				DeleteItem(index+1);
			partfile->srcarevisible = false;
		}
	}
  }

  SetRedraw(true);
}
