//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// StatisticsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "StatisticsDlg.h"
#include "uploadqueue.h"

// CStatisticsDlg dialog

IMPLEMENT_DYNAMIC(CStatisticsDlg, CDialog)
CStatisticsDlg::CStatisticsDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CStatisticsDlg::IDD, pParent) , m_DownloadOMeter( 2 ),m_Statistics(4),m_UploadOMeter(2)
{

}

CStatisticsDlg::~CStatisticsDlg()
{
}

void CStatisticsDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExoSliderDlg)
	DDX_Text(pDX, IDC_SLIDER_VALUE, m_SliderValue);
	DDX_Control(pDX, IDC_STATTREE, stattree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatisticsDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CStatisticsDlg)
	ON_WM_SHOWWINDOW()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CStatisticsDlg message handlers

BOOL CStatisticsDlg::OnInitDialog(){

	CResizableDialog::OnInitDialog();
	Localize();
	EnableWindow( FALSE );

	ShowSizeGrip(FALSE);
	AddAnchor(IDC_STATIC_LINE,TOP_LEFT ,TOP_RIGHT);
	AddAnchor(IDC_STATTREE,TOP_LEFT ,BOTTOM_RIGHT);

	// setup tree
	//h_general = stattree.InsertItem("General");
	h_transfer= stattree.InsertItem(GetResString(IDS_FSTAT_TRANSFER));
	h_connection = stattree.InsertItem(GetResString(IDS_FSTAT_CONNECTION));
	h_clients = stattree.InsertItem(GetResString(IDS_CLIENTS));
	h_servers = stattree.InsertItem(GetResString(IDS_FSTAT_SERVERS));

	h0= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);
	h1= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);
	h2= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);
	h3= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);
	h4= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);
	h5= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);
	h6= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_transfer);

	h7= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	h8= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	h9= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	h10= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);
	h11= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_connection);

	h12= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);
	h13= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);
	//h14= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);
	h15= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_clients);

	h16= stattree.InsertItem(GetResString(IDS_FSTAT_WAITING),h_servers);

	stattree.Expand(h_transfer,TVE_EXPAND);
	stattree.Expand(h_connection,TVE_EXPAND);
	stattree.Expand(h_clients,TVE_EXPAND);
	stattree.Expand(h_servers,TVE_EXPAND);


	// Setup download-scope
	CRect rect;
	GetDlgItem(IDC_SCOPE_D)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_DownloadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_DownloadOMeter.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_DownloadOMeter.SetGridColor(RGB(192, 192, 255)) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 0) ;
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 1) ;
	m_DownloadOMeter.SetPlotColor( RGB(0, 255, 0),1) ;
	m_DownloadOMeter.SetPlotColor( RGB(0, 150, 0),0) ;
	m_DownloadOMeter.SetYUnits("kB / s") ;
	//m_DownloadOMeter.SetXUnits(GetResString(IDS_TIME));

	// Setup upload-scope
	GetDlgItem(IDC_SCOPE_U)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_UploadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_UploadOMeter.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_UploadOMeter.SetGridColor(RGB(192, 192, 255)) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 0) ;
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 1) ;
	m_UploadOMeter.SetPlotColor( RGB(255, 0, 0),1) ;
	m_UploadOMeter.SetPlotColor( RGB(150, 0, 0),0) ;
	m_UploadOMeter.SetYUnits("kB / s") ;
	//m_UploadOMeter.SetXUnits(GetResString(IDS_TIME));

	// Setup additional graph-scope
	GetDlgItem(IDC_STATSSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_Statistics.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_Statistics.SetBackgroundColor(RGB(0, 0, 64)) ;
	m_Statistics.SetGridColor(RGB(192, 192, 255)) ;
	stat_max=40;
	m_Statistics.SetRanges(0, stat_max) ;
	m_Statistics.autofitYscale=true;

	m_Statistics.SetPlotColor( RGB(155, 155, 0)  ,0) ;
	m_Statistics.SetPlotColor( RGB(192, 0,   192),1) ;
	m_Statistics.SetPlotColor( RGB(255, 192, 255),2) ;
	m_Statistics.SetPlotColor( RGB(255, 255, 128),3) ;
	m_Statistics.SetYUnits("") ;
	m_Statistics.SetXUnits(GetResString(IDS_TIME));

	SetupLegend( IDC_C0,   1 ,1);
	SetupLegend( IDC_C0_2, 0 ,1);
	
	SetupLegend( IDC_C1,   1 ,2 );
	SetupLegend( IDC_C1_2, 0 ,2 );

	//SetupLegend( IDC_S0, 0 ,3);
	SetupLegend( IDC_S1, 1 ,3);
	//SetupLegend( IDC_S2, 2 ,3);
	SetupLegend( IDC_S3, 3 ,3);

	UpdateData(FALSE);

	EnableWindow( TRUE );

	return true;
}

void CStatisticsDlg::SetupLegend( int ResIdx, int ElmtIdx, int legendNr){
	CRect Rect;

	GetDlgItem( ResIdx )->GetWindowRect( Rect );
	ScreenToClient( Rect );
	
	if (legendNr==1){
		m_Led1[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led1[ ElmtIdx ].SetBackgroundColor( m_DownloadOMeter.GetPlotColor( ElmtIdx ) );
		m_Led1[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	} else if (legendNr==2) {
		m_Led2[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led2[ ElmtIdx ].SetBackgroundColor( m_UploadOMeter.GetPlotColor( ElmtIdx ) );
		m_Led2[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	} else if (legendNr==3){
		m_Led3[ ElmtIdx ].Create( WS_VISIBLE | WS_CHILD, Rect, this );
		m_Led3[ ElmtIdx ].SetBackgroundColor( m_Statistics.GetPlotColor( ElmtIdx ) );
		m_Led3[ ElmtIdx ].SetFrameColor( RGB( 0x00, 0x00, 0x00 ) );
	}
}


void CStatisticsDlg::SetCurrentRate(float uploadrate, float downloadrate) {
	double m_dPlotDataUp[ 2 ];
	double m_dPlotDataDown[ 2 ];

	// current rate
	m_dPlotDataDown[1]=downloadrate;
	m_dPlotDataUp[1]=uploadrate;

	// averages
	m_dPlotDataDown[0]=	GetAvgDownloadRate(AVG_SESSION);
	m_dPlotDataUp[0]=	GetAvgUploadRate(AVG_SESSION);


	// show
	m_DownloadOMeter.AppendPoints(m_dPlotDataDown);
	m_UploadOMeter.AppendPoints(m_dPlotDataUp);

}

void CStatisticsDlg::ShowStatistics() {

	char buffer[50];char buffer2[50];
	CString cbuffer;
	bool resize;
	int myStats[6];
	DWORD running;

	resize=false;
	// get Partialfiles summary
	theApp.downloadqueue->GetDownloadStats(myStats);

	m_dPlotDataMore[0]=0;//myStats[0];
	m_dPlotDataMore[1]=theApp.uploadqueue->GetUploadQueueLength();
	m_dPlotDataMore[2]=0;//theApp.uploadqueue->GetWaitingUserCount();
	m_dPlotDataMore[3]=myStats[1];

	for (int i=0;i<4;i++) if (m_dPlotDataMore[i]>stat_max) {resize=true;stat_max=(int)m_dPlotDataMore[i];}
	if (resize) m_Statistics.SetRanges(0, stat_max+15) ;
	 
	m_Statistics.AppendPoints(m_dPlotDataMore);

	CastItoXBytes( theApp.stat_sessionReceivedBytes ,buffer);
	CastItoXBytes( theApp.stat_sessionReceivedBytes+theApp.glob_prefs->GetTotalDownloaded() ,buffer2);
	cbuffer.Format(GetResString(IDS_STATS_DDATA),buffer,buffer2);
	stattree.SetItemText(h0, cbuffer);

	CastItoXBytes( theApp.stat_sessionSentBytes  ,buffer);
	CastItoXBytes( theApp.stat_sessionSentBytes+theApp.glob_prefs->GetTotalUploaded() ,buffer2);
	cbuffer.Format(GetResString(IDS_STATS_UDATA),buffer,buffer2);
	stattree.SetItemText(h1, cbuffer);

	if (theApp.stat_transferStarttime>0) {
		cbuffer.Format(GetResString(IDS_STATS_AVGDL),GetAvgDownloadRate(AVG_SESSION));
		stattree.SetItemText(h7, cbuffer);

		cbuffer.Format(GetResString(IDS_STATS_AVGUL),GetAvgUploadRate(AVG_SESSION));
		stattree.SetItemText(h8, cbuffer);
	}

	cbuffer.Format(GetResString(IDS_STATS_FOUNDSRC),myStats[0]);
	stattree.SetItemText(h3, cbuffer);

    cbuffer.Format(GetResString(IDS_STATS_ACTDL),myStats[1]);
	stattree.SetItemText(h4, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_ACTUL),theApp.uploadqueue->GetUploadQueueLength());
	stattree.SetItemText(h5, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_WAITINGUSERS),theApp.uploadqueue->GetWaitingUserCount());
	stattree.SetItemText(h6, cbuffer);

	if (theApp.stat_reconnects>0) cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),theApp.stat_reconnects-1);
		else cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),0);
	stattree.SetItemText(h9, cbuffer);

	if (theApp.stat_transferStarttime==0) cbuffer.Format(GetResString(IDS_STATS_WAITTRANSF)); else {
		running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
		CastSecondsToHM(running,buffer);
		cbuffer.Format("Time Since First Transfer: %s",buffer);
	}
	stattree.SetItemText(h10, cbuffer);

	if (theApp.stat_serverConnectTime==0) cbuffer.Format(GetResString(IDS_STATS_WAITCONN)); else {
		running=(GetTickCount()-theApp.stat_serverConnectTime)/1000;
		CastSecondsToHM(running,buffer);
		cbuffer.Format(GetResString(IDS_STATS_CONNECTEDSINCE),buffer);
	}
	stattree.SetItemText(h11, cbuffer);

	if (theApp.stat_sessionReceivedBytes>0 && theApp.stat_sessionSentBytes>0 )
		if (theApp.stat_sessionReceivedBytes<theApp.stat_sessionSentBytes) {
			cbuffer.Format(GetResString(IDS_STATS_RATIO)+" %.2f : 1",(float)theApp.stat_sessionSentBytes/theApp.stat_sessionReceivedBytes);
			stattree.SetItemText(h2, cbuffer);
		} else {
			cbuffer.Format(GetResString(IDS_STATS_RATIO)+" 1 : %.2f",(float)theApp.stat_sessionReceivedBytes/theApp.stat_sessionSentBytes);
			stattree.SetItemText(h2, cbuffer);
		}


	// get clientversion-counts
	theApp.clientlist->GetStatistics(myStats);
	cbuffer.Format("eMule: %i",myStats[2]);stattree.SetItemText(h12, cbuffer);
	cbuffer.Format("eDonkey: %i",myStats[1]);stattree.SetItemText(h13, cbuffer);
	//cbuffer.Format("mlDonkey: %i",myStats[3]);stattree.SetItemText(h14, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_UNKNOWNCLIENT),myStats[0]);stattree.SetItemText(h15, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_TOTAL)+": %i",theApp.serverlist->GetServerCount());stattree.SetItemText(h16, cbuffer);
}


float CStatisticsDlg::GetAvgDownloadRate(int averageType) {
	if (theApp.stat_transferStarttime ==0) return 0;

	DWORD running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
	if (running<5) return 0;

	return (float)(theApp.stat_sessionReceivedBytes/1024) / running;
}

float CStatisticsDlg::GetAvgUploadRate(int averageType) {
	if (theApp.stat_transferStarttime==0) return 0;

	DWORD running=(GetTickCount()-theApp.stat_transferStarttime)/1000;
	if (running<5) return 0;

	return (float)(theApp.stat_sessionSentBytes/1024) / running;
}

void CStatisticsDlg::OnShowWindow(BOOL bShow,UINT nStatus){

}

void CStatisticsDlg::OnSize(UINT nType, int cx, int cy)
{
	CResizableDialog::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	//this will cause COScopeCtrl::OnSizeCall
	CRect rc;
	GetDlgItem(IDC_UPLOAD)->GetWindowRect(&rc);
	ScreenToClient(&rc);
	m_DownloadOMeter.MoveWindow(&rc);

}  //OnSize

void CStatisticsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();
	
	theApp.glob_prefs->SetTrafficOMeterInterval(position);
	ShowInterval(false);

	UpdateData(false); 
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CStatisticsDlg::ShowInterval(bool setSliderPosition) {
	EnableWindow( FALSE );

	if (setSliderPosition) ((CSliderCtrl*)GetDlgItem(IDC_SLIDER))->
		SetPos(theApp.glob_prefs->GetTrafficOMeterInterval());
	
	if (theApp.glob_prefs->GetTrafficOMeterInterval()==0) m_SliderValue.Format(GetResString(IDS_DISABLED));
	else m_SliderValue.Format(GetResString(IDS_STATS_UPDATELABEL), theApp.glob_prefs->GetTrafficOMeterInterval());

	int shownSecs=319*theApp.glob_prefs->GetTrafficOMeterInterval();

	
	if (theApp.glob_prefs->GetTrafficOMeterInterval()==0) {
		m_DownloadOMeter.SetXUnits(GetResString(IDS_STOPPED)); 
		m_UploadOMeter.SetXUnits(GetResString(IDS_STOPPED)); 
	} else
	{
		char buffer[50];
		CastSecondsToHM(shownSecs,buffer);
		m_UploadOMeter.SetXUnits(buffer );
		m_DownloadOMeter.SetXUnits(buffer); 
	}

	UpdateData(FALSE);
	EnableWindow( TRUE );
}

void CStatisticsDlg::SetARange(bool SetDownload,int maxValue){
	if (SetDownload) {
		m_DownloadOMeter.SetRange(0, maxValue+4, 0);
		m_DownloadOMeter.SetRange(0, maxValue+4, 1);
	}else{
		m_UploadOMeter.SetRange(0, maxValue+4, 0) ;
		m_UploadOMeter.SetRange(0, maxValue+4, 1);
	}
}

void CStatisticsDlg::Localize(){
	GetDlgItem(IDC_STATIC_D3)->SetWindowText(GetResString(IDS_ST_DOWNLOAD));
	GetDlgItem(IDC_STATIC_U)->SetWindowText(GetResString(IDS_ST_UPLOAD));
	GetDlgItem(IDC_STATIC_D)->SetWindowText(GetResString(IDS_ST_CURRENT));
	GetDlgItem(IDC_STATIC_U2)->SetWindowText(GetResString(IDS_ST_CURRENT));
	GetDlgItem(IDC_STATIC_D2)->SetWindowText(GetResString(IDS_ST_SESSION));
	GetDlgItem(IDC_STATIC_U3)->SetWindowText(GetResString(IDS_ST_SESSION));
	GetDlgItem(IDC_STATIC_S2)->SetWindowText(GetResString(IDS_ST_ACTIVED));
	GetDlgItem(IDC_STATIC_S1)->SetWindowText(GetResString(IDS_ST_ACTIVEU));
	GetDlgItem(IDC_STATIC_S3)->SetWindowText(GetResString(IDS_ST_WAITINGU));
}
